HDU4283 You Are the One 区间DP

来源:互联网 发布:安居客网络经纪人平台 编辑:程序博客网 时间:2024/06/05 07:39

You Are the One

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 3012    Accepted Submission(s): 1343


Problem Description
  The TV shows such as You Are the One has been very popular. In order to meet the need of boys who are still single, TJUT hold the show itself. The show is hold in the Small hall, so it attract a lot of boys and girls. Now there are n boys enrolling in. At the beginning, the n boys stand in a row and go to the stage one by one. However, the director suddenly knows that very boy has a value of diaosi D, if the boy is k-th one go to the stage, the unhappiness of him will be (k-1)*D, because he has to wait for (k-1) people. Luckily, there is a dark room in the Small hall, so the director can put the boy into the dark room temporarily and let the boys behind his go to stage before him. For the dark room is very narrow, the boy who first get into dark room has to leave last. The director wants to change the order of boys by the dark room, so the summary of unhappiness will be least. Can you help him?
 

Input
  The first line contains a single integer T, the number of test cases.  For each case, the first line is n (0 < n <= 100)
  The next n line are n integer D1-Dn means the value of diaosi of boys (0 <= Di <= 100)
 

Output
  For each test case, output the least summary of unhappiness .
 

Sample Input
2  512345554322
 

Sample Output
Case #1: 20Case #2: 24
 

Source
2012 ACM/ICPC Asia Regional Tianjin Online
 

Recommend
liuyiding

    比较经典的一道区间DP题目,思路都是对区间进行分割。

    dp[i][j]表示单独考虑从第i个人到第j个人这段区间的最小不满意度,单独考虑意味着不考虑i之前的人,即把第i个人当做第一个人。

    首先考虑栈对于队列中元素的影响。我们假设不管需不需要调换顺序,每个人出队列之后必须进栈,然后再从栈中出去。这样假设第i个人从第一个出去变成第k个出去,那么

[i+1,i+k-1]这段区间的人必须比i先出去,而[i+k,j]这个区间的人必须在k后面出去,那么

dp[i][j]就会由三部分组成,

           dp[i+1][i+k-1],由于第i+1个人本来就是第一个出去,所以不变

           (k-1)*ds[i],第i个人变成第k个出去的不满意度

           dp[i+k][j]+(sum[j]-sum[i+k-1])*k,第i+k个人原本是第一个出去,现在

                                     变成第k+1个出去,因此他后面所有的人的不满意度都要增加


因此,最终的状态转移方程就是

dp[i][j]=min(dp[i][j],dp[i+1][i+k-1]+dp[i+k][j]+ds[i]*(k-1)+(sum[j]-sum[i+k-1])*k)


/*****************功能:元素在队列中,若想出队列,需要先进栈,然后出栈,每个元素出栈的时刻会影响其不满意度,求某个策略,使不满意度最小。参数:元素的不满意参数返回值:最小的不满意度*****************/#include <iostream>#include <stdio.h>#include <string.h>#define maxn 110#define INF 200000000using namespace std;int ds[maxn];int dp[maxn][maxn];int sum[maxn];void init(int n){    int i,j;    for(sum[0]=ds[0],i=1;i<n;i++)    {        sum[i]=sum[i-1]+ds[i];    }    memset(dp,0,sizeof(dp));    for(i=0;i<n;i++)        for(j=i+1;j<n;j++)            dp[i][j]=INF;}int solve(int n){    int i,j,k;    int len;    int tmp;    init(n);    for(len=1;len<=n;len++)    {        for(i=0;i<=n-len;i++)        {            j=i+len-1;            for(k=1;k<=len;k++)            {                tmp=min(dp[i][j],dp[i+1][i+k-1]+dp[i+k][j]+ds[i]*(k-1)+(sum[j]-sum[i+k-1])*k);                if(tmp<dp[i][j])                    dp[i][j]=tmp;            }        }    }    return dp[0][n-1];}int main(){    int T,cas=0,n;    int i;    scanf("%d",&T);    while(T--)    {        scanf("%d",&n);        for(i=0;i<n;i++)            scanf("%d",&ds[i]);        printf("Case #%d: %d\n",++cas,solve(n));    }    return 0;}/***********************输入:2  512345554322输出:Case #1: 20Case #2: 24***********************/





 

0 0